• 让AutoCAD.NET支持后台线程


    Use Thread for background processing

    By Adam Nagy

    From inside my command I'm starting a background thread that synchronizes with a database. Once that finishes I'd like to keep using the AutoCAD .NET API to do some further modifications in the database. Unfortunately, when I'm calling the AutoCAD API functions from this thread things do not seem to work, e.g. the MdiActiveDocument is null.

    Solution

    The AutoCAD API's do not support multithreading. You should only call the API functions from the main thread.

    If you are in a different thread then you have to marshal the call to the main thread. The simplest way to achieve that is creating a System.Windows.Forms.Control object on the main thread and call its Invoke() function to start the function that is doing the end processing.

    Here is a sample to demonstrate this.

    using System;

    using Autodesk.AutoCAD.Runtime;

    using System.Windows.Forms;

    using Autodesk.AutoCAD.EditorInput;

    using acApp = Autodesk.AutoCAD.ApplicationServices.Application;

    using Autodesk.AutoCAD.ApplicationServices;

    using Autodesk.AutoCAD.DatabaseServices;

    using Autodesk.AutoCAD.Geometry;

    namespace BackgroundProcess

    {

      public class Commands : IExtensionApplication

      {

        static Control syncCtrl;

        public void Initialize()

        {

          // The control created to help with marshaling

          // needs to be created on the main thread

          syncCtrl = new Control();

          syncCtrl.CreateControl();

        }

        public void Terminate()

        {

        }

        void BackgroundProcess()

        {

          // This is to represent the background process

          System.Threading.Thread.Sleep(5000);

          // Now we need to marshall the call to the main thread

          // I don't see how this could ever be false in this context,

          // but I check it anyway

          if (syncCtrl.InvokeRequired)

            syncCtrl.Invoke(

              new FinishedProcessingDelegate(FinishedProcessing));

          else

            FinishedProcessing();

        }

        delegate void FinishedProcessingDelegate();

        void FinishedProcessing()

        {

          // If we want to modify the database, then we need to lock

          // the document since we are in session/application context

          Document doc = acApp.DocumentManager.MdiActiveDocument;

          using (doc.LockDocument())

          {

            using (Transaction tr =

              doc.Database.TransactionManager.StartTransaction())

            {

              BlockTable bt =

                (BlockTable)tr.GetObject(

                doc.Database.BlockTableId, OpenMode.ForRead);

              BlockTableRecord ms = (BlockTableRecord)tr.GetObject(

                bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite);

              Line line =

                new Line(new Point3d(0, 0, 0), new Point3d(10, 10, 0));

              ms.AppendEntity(line);

              tr.AddNewlyCreatedDBObject(line, true);

              tr.Commit();

            }

          }

          // Also write a message to the command line

          // Note: using AutoCAD notification bubbles would be

          // a nicer solution :)

          // TrayItem/TrayItemBubbleWindow

          Editor ed = acApp.DocumentManager.MdiActiveDocument.Editor;

          ed.WriteMessage("Finished the background process!\n");

        }

        [CommandMethod("ProcessInBackground")]

        public void ProcessBackground()

        {

          // Let's say we got some data from the drawing and

          // now we want to process it in a background thread

          System.Threading.Thread thread =

            new System.Threading.Thread(

              new System.Threading.ThreadStart(BackgroundProcess));

          thread.Start();

          Editor ed = acApp.DocumentManager.MdiActiveDocument.Editor;

          ed.WriteMessage(

            "Started background processing. " + 

            "You can keep working as usual.\n");

        }

      }

    }

    原文链接:http://adndevblog.typepad.com/autocad/2012/06/use-thread-for-background-processing.html?cid=6a0167607c2431970b017742be1ec2970d

  • 相关阅读:
    IIS7 配置PHP服务器
    WebAPI Post请求多参数处理方案
    Mssql 跨域查询
    sql 给数据库表 字段 添加注释
    log4net配置文件
    搭建svn服务器小结
    Django测试开发-30- xadmin模板中class Meta:和def __str__(self):的应用
    Django测试开发-29- xadmin模板中详情页面布局form_layout详解
    Django测试开发-28- xadmin模板中related_name和_set()用法
    Django测试开发-27- xadmin模板中注册增加Student和Teacher,Card及CardDetail表
  • 原文地址:https://www.cnblogs.com/pyt5208/p/2732285.html
Copyright © 2020-2023  润新知